/*
 *   Unreal Internet Relay Chat Daemon, src/modules/m_sanick.c
 *   (C) 2000-2001 Carsten V. Munk and the UnrealIRCd Team
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


 /*

   SANICK and CHGNICK Module for Unrealircd 
   by Mouse 

   Credits to cryptoknight who coded sanick for Ultimate ircd.   
   http://sourceforge.net/projects/nolimit/

   why need to waste $30 ?  I can make one :P 
   http://www.codemastr.com/?page=module
   

 */

#include "config.h"
#include "struct.h"
#include "common.h"
#include "sys.h"
#include "numeric.h"
#include "msg.h"
#include "channel.h"
#include <time.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef _WIN32
#include <io.h>
#endif
#include <fcntl.h>
#include "h.h"
#include "proto.h"
#ifdef STRIPBADWORDS
#include "badwords.h"
#endif
#ifdef _WIN32
#include "version.h"
#endif

DLLFUNC int m_sanick(aClient *cptr, aClient *sptr, int parc, char *parv[]);

/* Place includes here */
#define MSG_SANICK     "SANICK"
#define MSG_CHGNICK     "CHGNICK"
#define TOK_SANICK     "SN"
#define TOK_CHGICK     "CN"

ModuleHeader MOD_HEADER(m_sanick)
  = {
	"sanick",	/* Name of module */
	"$Id: m_sanick.c,v 1.0.0.0 2004/6/1 19:42:32 Mouse Exp $", /* Version */
	"command /sanick", /* Short description of module */
	"3.2-b8-1",
	NULL 
    };


/* This is called on module init, before Server Ready */
DLLFUNC int MOD_INIT(m_chgname)(ModuleInfo *modinfo)
{
	/*
	 * We call our add_Command crap here
	*/
	add_Command(MSG_SANICK, TOK_SANICK, m_sanick, 2);
        add_Command(MSG_CHGNICK, TOK_SANICK, m_sanick, 2);
	MARK_AS_OFFICIAL_MODULE(modinfo);
	return MOD_SUCCESS;
}

/* Is first run when server is 100% ready */
DLLFUNC int MOD_LOAD(m_chgname)(int module_load)
{
	return MOD_SUCCESS;
	
}


/* Called when module is unloaded */
DLLFUNC int MOD_UNLOAD(m_sanick)(int module_unload)
{
	if (del_Command(MSG_SANICK, TOK_SANICK, m_sanick) < 0)
	{
		sendto_realops("Failed to delete command chgname when unloading %s",
				MOD_HEADER(m_sanick).name);
	}
	if (del_Command(MSG_CHGNICK, TOK_SANICK, m_sanick) < 0)
	{
		sendto_realops("Failed to delete command svsname when unloading %s",
				MOD_HEADER(m_sanick).name);
	}
	return MOD_SUCCESS;
	
}


/*
** m_sanick() - PID - 12-19-2002
**
**      parv[0] - sender
**      parv[1] - nick to make join
**      parv[2] - channel(s) to join
*/
int     m_sanick(aClient * cptr, aClient * sptr, int parc, char *parv[])  {
        aClient *acptr;
        if (!IsOper(sptr) && !IsAdmin(sptr) && !IsULine(sptr))   {
                sendto_one(sptr, err_str(ERR_NOPRIVILEGES), me.name, parv[0]);
                return 0;
        }
                                                                                                                             
        if (parc!=3 || !(acptr = find_person(parv[1], NULL)))
                return 0;
                                                                                                                             
        sendto_realops("%s used SANICK to change %s to %s", parv[0], parv[1], parv[2]);
                                                                                                                             
        if(MyClient(acptr)) {
                parv [0] = parv [1];
                parv [1] = parv [2];
             sendto_one(acptr, ":%s NOTICE %s :*** You decided to change your nick to %s", me.name, acptr->name, parv[2]);

                 (void)m_nick(acptr,acptr,2,parv);
        }
        else
        sendto_serv_butone(cptr, ":%s SANICK %s %s", parv[0],
                        parv[1], parv[2]);
 
        return 0;
}

